<?php
/* Copyright start
  Copyright (C) 2008 - 2020 Fortinet Inc.
  All rights reserved.
  FORTINET CONFIDENTIAL & FORTINET PROPRIETARY SOURCE CODE
  Copyright end */

namespace Cybersponse\AuthorizationBundle\Subscriber;

use Cybersponse\AuthorizationBundle\Entity\Team;
use Cybersponse\CoreBundle\Provider\CacheableInterface;
use Dunglas\ApiBundle\Event\DataEvent;
use Dunglas\ApiBundle\Event\Events;
use Symfony\Component\EventDispatcher\EventSubscriberInterface;

class SecurityTeamsCacheSubscriber implements EventSubscriberInterface
{
    /** @var CacheableInterface[] */
    protected $caches = [];

    /**
     * @param CacheableInterface $cache
     */
    public function addCache($cache)
    {
        $this->caches[] = $cache;
    }

    /**
     * @inheritdoc
     */
    public static function getSubscribedEvents()
    {
        return [
            Events::POST_UPDATE => ['clearAllPermissionsCache', 0],
            Events::POST_CREATE => ['clearAllPermissionsCache', 0],
            Events::POST_DELETE => ['clearAllPermissionsCache', 0]
        ];
    }

    /**
     * @param DataEvent $dataEvent
     */
    public function clearAllPermissionsCache(DataEvent $dataEvent)
    {
        $object = $dataEvent->getData();

        if ($object instanceof Team) {
            foreach ($this->caches as $cache) {
                $cache->clearCache();
            }
        }
    }
}