<?php
/* Copyright start
  Copyright (C) 2008 - 2020 Fortinet Inc.
  All rights reserved.
  FORTINET CONFIDENTIAL & FORTINET PROPRIETARY SOURCE CODE
  Copyright end */

namespace Cybersponse\CoreBundle\Controller;

use Symfony\Component\Security\Core\Exception\AccessDeniedException;
use Symfony\Component\HttpFoundation\Request;
use Dunglas\ApiBundle\JsonLd\Response;

class AllActorsController extends AuthorizationResourceController
{

    public function checkAuthorized($permission_type)
    {
        $authorizationChecker = $this->container->get('');
        if (!$authorizationChecker->isGranted(['perm:application.read']) || !$authorizationChecker->isGranted(['perm:security.read'])) {
            throw new AccessDeniedException();
        }
    }

    public function getActorsAction(Request $request)
    {
        $__selectFields = ['id', '@id', '@type', 'userId', 'firstname', 'lastname', 'name'];
        $resource = $this->identifyResourceByShortName('people');
        $data = $this->getCollectionData($resource, $request);
        if ($request->get($this->container->getParameter('api.collection.pagination.page_parameter_name')) &&
            0 === count($data)) {
            throw $this->createNotFoundException();
        }
        $normalized_people = $this->get('serializer')->normalize(
            $data,
            'json-ld',
            $resource->getNormalizationContext() + ['required_attributes' => $__selectFields]
        );
        $resource = $this->identifyResourceByShortName('appliances');
        $data = $this->getCollectionData($resource, $request);
        if ($request->get($this->container->getParameter('api.collection.pagination.page_parameter_name')) &&
            0 === count($data)) {
            throw $this->createNotFoundException();
        }
        $normalized_appliance = $this->get('serializer')->normalize(
            $data,
            'json-ld',
            $resource->getNormalizationContext() + ['required_attributes' => $__selectFields]
        );
        $normalizedData['hydra:member'] = array_merge($normalized_people['hydra:member'], $normalized_appliance['hydra:member']);
        $normalizedData['@context'] = "/api/3/contexts/Person";
        $normalizedData['hydra:itemsPerPage'] = 30;
        $normalizedData['hydra:totalItems'] = sizeof($normalizedData['hydra:member']);
        return new Response($normalizedData, Response::HTTP_OK);
    }
}
