<?php
/* Copyright start
  Copyright (C) 2008 - 2020 Fortinet Inc.
  All rights reserved.
  FORTINET CONFIDENTIAL & FORTINET PROPRIETARY SOURCE CODE
  Copyright end */
namespace Cybersponse\FilesBundle\Entity;

use Cybersponse\MetadataBundle\Generation\Annotations\Fields\Readable\Readable;
use Doctrine\ORM\Mapping as ORM;
use Cybersponse\CoreBundle\Entity\BaseEntity;

/**
 * Class AbstractFile
 *
 */
abstract class AbstractFile extends BaseEntity
{

    /**
     * @ORM\Column(name="`id`", type="string", length=150, nullable=true, unique=true)
     * @Cybersponse\MetadataBundle\Generation\Annotations\Fields\Title\Title(name="Id")
     */
    protected $id;

    /**
     * 
     * @Doctrine\ORM\Mapping\Column(name="`file`", type="string", length=255, nullable=true, unique=true)
     * @Cybersponse\MetadataBundle\Generation\Annotations\Fields\Title\Title(name="File")
     * @Cybersponse\MetadataBundle\Generation\Annotations\Fields\FormType\FormType(type="file")
     */
    protected $file;
    /**
     * @var string
     *
     * @Doctrine\ORM\Mapping\Column(name="`filename`", type="string", length=255, nullable=true, unique=false)
     * @Cybersponse\MetadataBundle\Generation\Annotations\Fields\Title\Title(name="FileName")
     */
    protected $filename;
    /**
     * @var string
     *
     * @Doctrine\ORM\Mapping\Column(name="`mimeType`", type="string", length=255, nullable=true, unique=false)
     * @Cybersponse\MetadataBundle\Generation\Annotations\Fields\Title\Title(name="Mime Type")
     */
    protected $mimeType;
    
    /**
     * @var \DateTime
     *
     * @Doctrine\ORM\Mapping\Column(name="uploaddate", type="datetime", nullable=true)
     * @Cybersponse\MetadataBundle\Generation\Annotations\Fields\FormType\FormType(type="datetime")
     * @Cybersponse\MetadataBundle\Generation\Annotations\Fields\Title\Title(name="Upload Date")
     */
    protected $uploadDate;
    /**
     * @Cybersponse\MetadataBundle\Generation\Annotations\Fields\Title\Title(name="Size")
     * @Doctrine\ORM\Mapping\Column(name="size", type="integer", nullable=true)
     */
    protected $size;

    /**
     * Set file
     *
     * @param \Symfony\Component\HttpFoundation\File\File $file
     * @return self
     */
    public function setFile($file)
    {
        $this->file = $file;
        return $this;
    }

    /**
     * Get file
     *
     * @return \Symfony\Component\HttpFoundation\File\File $file
     */
    public function getFile()
    {
        return $this->file;
    }

    /**
     * Set filename
     *
     * @param string $filename
     * @return self
     */
    public function setFilename($filename)
    {
        $this->filename = $filename;
        return $this;
    }

    /**
     * Get filename
     *
     * @return string $filename
     */
    public function getFilename()
    {
        return $this->filename;
    }

    /**
     * Set mimeType
     *
     * @param string $mimeType
     * @return self
     */
    public function setMimeType($mimeType)
    {
        $this->mimeType = $mimeType;
        return $this;
    }

    /**
     * Get mimeType
     *
     * @return string $mimeType
     */
    public function getMimeType()
    {
        return $this->mimeType;
    }


    /**
     * Set uploadDate
     *
     * @param int $uploadDate
     * @return self
     */
    public function setUploadDate($uploadDate)
    {
        $this->uploadDate = $uploadDate;
        return $this;
    }

    /**
     * Get uploadDate
     *
     * @return int $uploadDate
     */
    public function getUploadDate()
    {
        return $this->uploadDate;
    }

    /**
     * Set size
     *
     * @param integer $size
     * @return self
     */
    public function setSize($size)
    {
        $this->size = $size;
        return $this;
    }

    /**
     * Get size
     *
     * @return integer $size
     */
    public function getSize()
    {
        return $this->size;
    }

    /**
     * Get the value of id
     */ 
    public function getId()
    {
        return $this->id;
    }
    /**
     * Set the value of id
     *
     * @return  self
     */ 
    public function setId($id)
    {
        $this->id = $id;
        return $this;
    }
}
