<?php
/* Copyright start
  Copyright (C) 2008 - 2020 Fortinet Inc.
  All rights reserved.
  FORTINET CONFIDENTIAL & FORTINET PROPRIETARY SOURCE CODE
  Copyright end */

namespace Cybersponse\QueryBundle\Query;


class Query implements ExpressionInterface
{
    /** @var string */
    protected $logic;

    /** @var ExpressionInterface[] */
    protected $filters = [];

    /**
     * @param string $logic
     * @param ExpressionInterface[] $filters
     */
    public function __construct($logic, $filters = [])
    {
        $this->logic = $logic;
        $this->filters = $filters;
    }

    /**
     * @param ExpressionInterface $filter
     * @return self
     */
    public function addFilter($filter)
    {
        $this->filters[] = $filter;
        return $this;
    }

    public function toArray()
    {
        return [
            'logic' => $this->logic,
            'filters' => array_map(function (ExpressionInterface $filter) {
                return $filter->toArray();
            }, $this->filters)
        ];
    }
}
