<?php
/* Copyright start
  Copyright (C) 2008 - 2020 Fortinet Inc.
  All rights reserved.
  FORTINET CONFIDENTIAL & FORTINET PROPRIETARY SOURCE CODE
  Copyright end */

namespace Cybersponse\TestBundle\Entity;

use Doctrine\ORM\Mapping as ORM;

/**
 * MockAEntity
 *
 * @Doctrine\ORM\Mapping\Table(name="mock_a_entities")
 * @Doctrine\ORM\Mapping\Entity(repositoryClass="Doctrine\ORM\EntityRepository")
 * @Cybersponse\MetadataBundle\Generation\Annotations\Classes\ModelType\ModelType(modelType="mock_a_entities")
 * @Cybersponse\MetadataBundle\Generation\Annotations\Classes\Descriptions\Descriptions(singular="Mock A Entity",plural="Mock A Entities")
 */
class MockAEntity extends \Cybersponse\CoreBundle\Entity\BaseEntity
{
    /**
     * @var \Doctrine\Common\Collections\Collection
     *
     * @Doctrine\ORM\Mapping\ManyToMany(targetEntity="Cybersponse\TestBundle\Entity\MockMEntity", inversedBy="mockAEntities", cascade={"persist"}, fetch="EXTRA_LAZY")
     * @Doctrine\ORM\Mapping\JoinTable(name="mockaentity_mockmentity",
     *   joinColumns={
     *     @Doctrine\ORM\Mapping\JoinColumn(name="mockaentity_uuid", referencedColumnName="uuid", onDelete="CASCADE")
     *   },
     *   inverseJoinColumns={
     *     @Doctrine\ORM\Mapping\JoinColumn(name="mockmentity_uuid", referencedColumnName="uuid", onDelete="CASCADE")
     *   }
     * )
     * @Cybersponse\MetadataBundle\Generation\Annotations\Fields\DataSource\DataSource(model="mock_m_entities")
     * @Cybersponse\MetadataBundle\Generation\Annotations\Fields\Title\Title(name="Mock M Entities")
     * @Cybersponse\MetadataBundle\Generation\Annotations\Fields\FormType\FormType(type="manyToMany")
     * @Cybersponse\MetadataBundle\Generation\Annotations\Fields\Normalize\Normalize()
     * @Cybersponse\MetadataBundle\Generation\Annotations\Fields\Denormalize\Denormalize()
     */
    protected $mockMEntities;

    /**
     * Constructor
     */
    public function __construct()
    {
        $this->mockMEntities = new \Doctrine\Common\Collections\ArrayCollection();
    }

    /**
     * Add mockMEntities
     *
     * @param \Cybersponse\TestBundle\Entity\MockMEntity  $mockMEntity
     *
     * @return MockAEntity
     */
    public function addMockEntity(\Cybersponse\TestBundle\Entity\MockMEntity $mockMEntity)
    {
        $this->mockMEntities[] = $mockMEntity;

        return $this;
    }

    /**
     * Remove mockMEntities
     *
     * @param \Cybersponse\TestBundle\Entity\MockMEntity  $mockMEntity
     */
    public function removeMockEntity(\Cybersponse\TestBundle\Entity\MockMEntity $mockMEntity)
    {
        $this->mockMEntities->removeElement($mockMEntity);
    }

    /**
     * Get mockMEntities
     *
     * @return \Doctrine\Common\Collections\Collection
     */
    public function getMockMEntities()
    {
        return $this->mockMEntities;
    }
}

