<?php
/* Copyright start
  Copyright (C) 2008 - 2020 Fortinet Inc.
  All rights reserved.
  FORTINET CONFIDENTIAL & FORTINET PROPRIETARY SOURCE CODE
  Copyright end */

namespace Cybersponse\TestBundle\Entity;

use Doctrine\ORM\Mapping as ORM;

/**
 * MockMEntity
 *
 * @Doctrine\ORM\Mapping\Table(name="mock_m_entities")
 * @Doctrine\ORM\Mapping\Entity(repositoryClass="Doctrine\ORM\EntityRepository")
 * @Cybersponse\MetadataBundle\Generation\Annotations\Classes\ModelType\ModelType(modelType="mock_m_entities")
 * @Cybersponse\MetadataBundle\Generation\Annotations\Classes\Descriptions\Descriptions(singular="Mock M Entity",plural="Mock M Entities")
 */
class MockMEntity extends \Cybersponse\CoreBundle\Entity\BaseEntity
{
    /**
     * @var \Doctrine\Common\Collections\Collection
     *
     * @Doctrine\ORM\Mapping\ManyToMany(targetEntity="Cybersponse\TestBundle\Entity\MockAEntity", inversedBy="mockMEntities", cascade={"persist"}, fetch="EXTRA_LAZY")
     * @Cybersponse\MetadataBundle\Generation\Annotations\Fields\DataSource\DataSource(model="mock_a_entities")
     * @Cybersponse\MetadataBundle\Generation\Annotations\Fields\Title\Title(name="Mock A Entities")
     * @Cybersponse\MetadataBundle\Generation\Annotations\Fields\FormType\FormType(type="manyToMany")
     * @Cybersponse\MetadataBundle\Generation\Annotations\Fields\Normalize\Normalize()
     * @Cybersponse\MetadataBundle\Generation\Annotations\Fields\Denormalize\Denormalize()
     */
    protected $mockAEntities;

    /**
     * @var \Doctrine\Common\Collections\Collection
     *
     * @Doctrine\ORM\Mapping\ManyToMany(targetEntity="Cybersponse\TestBundle\Entity\MockZEntity", inversedBy="mockMEntities", cascade={"persist"}, fetch="EXTRA_LAZY")
     * @Cybersponse\MetadataBundle\Generation\Annotations\Fields\DataSource\DataSource(model="mock_z_entities")
     * @Cybersponse\MetadataBundle\Generation\Annotations\Fields\Title\Title(name="Mock Z Entities")
     * @Cybersponse\MetadataBundle\Generation\Annotations\Fields\FormType\FormType(type="manyToMany")
     * @Cybersponse\MetadataBundle\Generation\Annotations\Fields\Normalize\Normalize()
     * @Cybersponse\MetadataBundle\Generation\Annotations\Fields\Denormalize\Denormalize()
     */
    protected $mockZEntities;

    /**
     * Constructor
     */
    public function __construct()
    {
        $this->mockAEntities = new \Doctrine\Common\Collections\ArrayCollection();
        $this->mockZEntities = new \Doctrine\Common\Collections\ArrayCollection();
    }

    /**
     * Add mockZEntities
     *
     * @param \Cybersponse\TestBundle\Entity\MockZEntity  $mockZEntity
     *
     * @return MockMEntity
     */
    public function addMockZEntity(\Cybersponse\TestBundle\Entity\MockZEntity $mockZEntity)
    {
        $this->mockZEntities[] = $mockZEntity;

        return $this;
    }

    /**
     * Remove mockZEntities
     *
     * @param \Cybersponse\TestBundle\Entity\MockZEntity  $mockZEntity
     */
    public function removeMockZEntity(\Cybersponse\TestBundle\Entity\MockZEntity $mockZEntity)
    {
        $this->mockZEntities->removeElement($mockZEntity);
    }

    /**
     * Get mockZEntities
     *
     * @return \Doctrine\Common\Collections\Collection
     */
    public function getMockZEntities()
    {
        return $this->mockZEntities;
    }

    /**
     * Add mockAEntities
     *
     * @param \Cybersponse\TestBundle\Entity\MockAEntity  $mockAEntity
     *
     * @return MockMEntity
     */
    public function addMockAEntity(\Cybersponse\TestBundle\Entity\MockAEntity $mockAEntity)
    {
        $this->mockAEntities[] = $mockAEntity;

        return $this;
    }

    /**
     * Remove mockAEntities
     *
     * @param \Cybersponse\TestBundle\Entity\MockAEntity  $mockAEntity
     */
    public function removeMockAEntity(\Cybersponse\TestBundle\Entity\MockAEntity $mockAEntity)
    {
        $this->mockAEntities->removeElement($mockAEntity);
    }

    /**
     * Get mockAEntities
     *
     * @return \Doctrine\Common\Collections\Collection
     */
    public function getMockAEntities()
    {
        return $this->mockAEntities;
    }
}

