<?php
/* Copyright start
  Copyright (C) 2008 - 2020 Fortinet Inc.
  All rights reserved.
  FORTINET CONFIDENTIAL & FORTINET PROPRIETARY SOURCE CODE
  Copyright end */

namespace Cybersponse\TestBundle\Entity;

use Doctrine\ORM\Mapping as ORM;

/**
 * MockZEntity
 *
 * @Doctrine\ORM\Mapping\Table(name="mock_z_entity")
 * @Doctrine\ORM\Mapping\Entity(repositoryClass="Doctrine\ORM\EntityRepository")
 * @Cybersponse\MetadataBundle\Generation\Annotations\Classes\ModelType\ModelType(modelType="mock_z_entities")
 * @Cybersponse\MetadataBundle\Generation\Annotations\Classes\Descriptions\Descriptions(singular="Mock Z Entity",plural="Mock Z Entities")
 */
class MockZEntity extends \Cybersponse\CoreBundle\Entity\BaseEntity
{
    /**
     * @var \Doctrine\Common\Collections\Collection
     *
     * @Doctrine\ORM\Mapping\ManyToMany(targetEntity="Cybersponse\TestBundle\Entity\MockAEntity", inversedBy="mockZEntities", cascade={"persist"}, fetch="EXTRA_LAZY")
     * @Doctrine\ORM\Mapping\JoinTable(name="mockaentity_mockzentity",
     *   joinColumns={
     *     @Doctrine\ORM\Mapping\JoinColumn(name="mockaentity_uuid", referencedColumnName="uuid", onDelete="CASCADE")
     *   },
     *   inverseJoinColumns={
     *     @Doctrine\ORM\Mapping\JoinColumn(name="mockzentity_uuid", referencedColumnName="uuid", onDelete="CASCADE")
     *   }
     * )
     * @Cybersponse\MetadataBundle\Generation\Annotations\Fields\DataSource\DataSource(model="mock_a_entities")
     * @Cybersponse\MetadataBundle\Generation\Annotations\Fields\Title\Title(name="Mock A Entities")
     * @Cybersponse\MetadataBundle\Generation\Annotations\Fields\FormType\FormType(type="manyToMany")
     * @Cybersponse\MetadataBundle\Generation\Annotations\Fields\Normalize\Normalize()
     * @Cybersponse\MetadataBundle\Generation\Annotations\Fields\Denormalize\Denormalize()
     */
    protected $mockAEntities;

    /**
     * Constructor
     */
    public function __construct()
    {
        $this->mockAEntities = new \Doctrine\Common\Collections\ArrayCollection();
    }

    /**
     * Add mockAEntities
     *
     * @param \Cybersponse\TestBundle\Entity\MockAEntity  $mockAEntity
     *
     * @return MockZEntity
     */
    public function addMockAEntity(\Cybersponse\TestBundle\Entity\MockAEntity $mockAEntity)
    {
        $this->mockAEntities[] = $mockAEntity;

        return $this;
    }

    /**
     * Remove mockAEntities
     *
     * @param \Cybersponse\TestBundle\Entity\MockAEntity  $mockAEntity
     */
    public function removeMockAEntity(\Cybersponse\TestBundle\Entity\MockAEntity $mockAEntity)
    {
        $this->mockAEntities->removeElement($mockAEntity);
    }

    /**
     * Get mockAEntities
     *
     * @return \Doctrine\Common\Collections\Collection
     */
    public function getMockAEntities()
    {
        return $this->mockAEntities;
    }
}

