Running Tests
-------------

Unit tests are only set up to run in a *dev* or *test* environment. Functional tests are only set up to run in a *test* environment. To set up a *test* environment, you must use `python manage.py reset -e CRUDHUB_ENVIRONMENT=test` and type *dev* as your environment (only CH is set up to provision a *test* environment at this time)

### Unit Test Suite

`chunit` is an alias created to execute phpunit with `--testsuite="Unit Test Suite"`

``` sh
[vagrant@dev ~]$ chunit
PHPUnit 4.8.24 by Sebastian Bergmann and contributors.

...............................................................  63 / 179 ( 35%)
............................................................... 126 / 179 ( 70%)
.....................................................

Time: 2.73 seconds, Memory: 15.25Mb

OK (179 tests, 187 assertions)
```

### Functional Test Suite

`chfunc` is an alias created to execute phpunit with `--testsuite="Functional Test Suite"`

``` sh
[vagrant@dev ~]$ chfunc
PHPUnit 4.8.24 by Sebastian Bergmann and contributors.

.....................S....SSS........................

Time: 1.32 minutes, Memory: 516.25Mb

OK, but incomplete, skipped, or risky tests!
Tests: 53, Assertions: 48, Skipped: 4.
```

### Full Test Suite

`chfull` is an alias created to execute phpunit with `--testsuite="Full Test Suite"`

``` sh
[vagrant@dev ~]$ chfull
PHPUnit 4.8.24 by Sebastian Bergmann and contributors.

.........................S....SSS..............................  63 / 232 ( 27%)
............................................................... 126 / 232 ( 54%)
............................................................... 189 / 232 ( 81%)
...........................................

Time: 1.31 minutes, Memory: 521.25Mb

OK, but incomplete, skipped, or risky tests!
Tests: 232, Assertions: 235, Skipped: 4.
```
